<?php
class Database
{
private static $_singleton;
private $linkID;
private function __construct($hostname, $username, $password, $database, $debug=False){
$this->debug = $debug;
$this->linkID = 0;
$this->queryID = 0;
$this->queryCount = 0;
$this->errNo = 0;
$this->errStr = '';
if (! ($hostname and $username and $database))
$this->halt('Missing parameters.');
$this->linkID = mysql_connect($hostname, $username, $password);
if (! $this->linkID)
$this->halt('linkID == False. Connect failed.');
if (! mysql_select_db($database, $this->linkID))
$this->halt("Cannot use database '$database'.");
}
public static function getInstance($hostname, $username, $password, $database, $debug=False){
if (is_null (self::$_singleton)) {
self::$_singleton = new Database($hostname, $username, $password, $database, $debug=False);
}
return self::$_singleton;
}
function halt($msg)
{
trigger_error(
sprintf("Database error %d: %s<br />%s\n",
$this->errNo, $this->errStr, $msg),
E_USER_ERROR);
}
function quote($str)
{
if (get_magic_quotes_gpc())
$str = stripslashes($str);
$str = mysql_real_escape_string($str);
$str = "'$str'";
return $str;
}
function buildQuery($sql, $params=array())
{
$sql_raw = strtr($sql, array('%' => '%%', '?' => '%s'));
$toeval = '$sql = sprintf($sql_raw';
for ($i = 0; $i < count($params); $i++)
$toeval .= ', $this->quote($params[' . $i . '])';
$toeval .= ');';
eval($toeval);
return $sql;
}
function query($sql, $params=array())
{
$sql = chop($sql);
if ($params)
$sql = $this->buildQuery($sql, $params);
$this->queryCount++;
if ($this->debug)
printf("SQL query #%d: %s<br />\n", $this->queryCount, $sql);
$this->queryID = mysql_query($sql, $this->linkID);
$this->errNo = mysql_errno();
$this->errStr = mysql_error();
if (! $this->queryID)
$this->halt('Invalid SQL: ' . $sql);
return $this->queryID;
}
function getOne($sql, $params=array())
{
$result = $this->query($sql, $params);
$row = mysql_fetch_array($result);
return $row[0];
}
function getCol($sql, $params=array())
{
$fields = array();
for (
$result = $this->query($sql, $params);
$row = mysql_fetch_array($result);
$fields[] = $row[0]);
return $fields;
}
function getRow($sql, $params=array())
{
$result = $this->query($sql, $params);
return mysql_fetch_assoc($result);
}
function getRows($sql, $params=array())
{
$rows = array();
for (
$result = $this->query($sql, $params);
$row = mysql_fetch_assoc($result);
$rows[] = $row);
return $rows;
}
function insert($table, $values)
{
$this->query(
sprintf(
'INSERT INTO `%s` (%s) VALUES (%s);',
$table,
join(', ', array_keys($values)),
join(', ', array_fill(0, count($values), '?'))
),
array_values($values));
return mysql_insert_id();
}
function update($table, $set, $where, $params=array())
{
if (ctype_digit((string) $where))
$where = 'id = ' . $where;
$this->query(
sprintf('UPDATE `%s` SET %s WHERE %s;', $table, $set, $where),
$params);
}
function delete($table, $where, $params=array())
{
if (ctype_digit((string) $where))
$where = 'id = ' . $where;
$this->query(
sprintf('DELETE FROM `%s` WHERE %s;', $table, $where),
$params);
}
function numCols()
{
return mysql_num_fields($this->queryID);
}
function numRows()
{
return mysql_num_rows($this->queryID);
}
function affectedRows()
{
return mysql_affected_rows($this->queryID);
}
function getQueryCount()
{
return $this->queryCount;
}
}
?>